#ifndef E_KBD_INT_H
#define E_KBD_INT_H

#include "e_kbd_buf.h"

typedef enum _E_Kbd_Int_Type
{
   E_KBD_INT_TYPE_UNKNOWN = 0,
   E_KBD_INT_TYPE_ALPHA = (1 << 0),
   E_KBD_INT_TYPE_NUMERIC = (1 << 1),
   E_KBD_INT_TYPE_FULL = (1 << 2)
} E_Kbd_Int_Type;

typedef struct _E_Kbd_Int           E_Kbd_Int;
typedef struct _E_Kbd_Int_Key       E_Kbd_Int_Key;
typedef struct _E_Kbd_Int_Key_State E_Kbd_Int_Key_State;

struct _E_Kbd_Int
{
   E_Win              *win;
   const char         *themedir, *syskbds, *sysdicts;
   Evas_Object        *base_obj, *layout_obj, *event_obj;
   Evas_List          *layouts;
   struct {
      char            *directory;
      const char      *file;
      int              w, h;
      int              fuzz;
      E_Kbd_Int_Type   type;
      Evas_List       *keys;
      E_Kbd_Int_Key   *pressed;
      int              state;
   } layout;
   struct {
      Evas_Coord        x, y;
      int               lx, ly;
      Ecore_Timer      *hold_timer;
      unsigned char     down : 1;
      unsigned char     stroke : 1;
   } down;
                     
   E_Kbd_Buf           *kbuf;
};

struct _E_Kbd_Int_Key
{
   int x, y, w, h;
   
   Evas_List *states;
   Evas_Object *obj, *icon_obj;

   unsigned char pressed : 1;
   unsigned char selected : 1;
   
   unsigned char is_shift : 1;
   unsigned char is_ctrl : 1;
   unsigned char is_alt : 1;
   unsigned char is_capslock : 1;
};

struct _E_Kbd_Int_Key_State
{
   int state;
   const char *label, *icon;
   const char *out;
};
    
#endif
